Index: django/tests/regressiontests/forms/localflavor/cl.py
===================================================================
--- django/tests/regressiontests/forms/localflavor/cl.py	(revision 9912)
+++ django/tests/regressiontests/forms/localflavor/cl.py	(working copy)
@@ -70,5 +70,5 @@
 >>> f = CLRegionSelect()

 >>> f.render('foo', 'bar')
-u'<select name="foo">\n<option value="RM">Regi\xf3n Metropolitana de Santiago</option>\n<option value="I">Regi\xf3n de Tarapac\xe1</option>\n<option value="II">Regi\xf3n de Antofagasta</option>\n<option value="III">Regi\xf3n de Atacama</option>\n<option value="IV">Regi\xf3n de Coquimbo</option>\n<option value="V">Regi\xf3n de Valpara\xedso</option>\n<option value="VI">Regi\xf3n del Libertador Bernardo O&#39;Higgins</option>\n<option value="VII">Regi\xf3n del Maule</option>\n<option value="VIII">Regi\xf3n del B\xedo B\xedo</option>\n<option value="IX">Regi\xf3n de la Araucan\xeda</option>\n<option value="X">Regi\xf3n de los Lagos</option>\n<option value="XI">Regi\xf3n de Ays\xe9n del General Carlos Ib\xe1\xf1ez del Campo</option>\n<option value="XII">Regi\xf3n de Magallanes y la Ant\xe1rtica Chilena</option>\n<option value="XIV">Regi\xf3n de Los R\xedos</option>\n<option value="XV">Regi\xf3n de Arica-Parinacota</option>\n</select>'
+u'<select name="foo">\n<option value="">---------</option>\n<option value="RM">Regi\xf3n Metropolitana de Santiago</option>\n<option value="I">Regi\xf3n de Tarapac\xe1</option>\n<option value="II">Regi\xf3n de Antofagasta</option>\n<option value="III">Regi\xf3n de Atacama</option>\n<option value="IV">Regi\xf3n de Coquimbo</option>\n<option value="V">Regi\xf3n de Valpara\xedso</option>\n<option value="VI">Regi\xf3n del Libertador Bernardo O&#39;Higgins</option>\n<option value="VII">Regi\xf3n del Maule</option>\n<option value="VIII">Regi\xf3n del B\xedo B\xedo</option>\n<option value="IX">Regi\xf3n de la Araucan\xeda</option>\n<option value="X">Regi\xf3n de los Lagos</option>\n<option value="XI">Regi\xf3n de Ays\xe9n del General Carlos Ib\xe1\xf1ez del Campo</option>\n<option value="XII">Regi\xf3n de Magallanes y la Ant\xe1rtica Chilena</option>\n<option value="XIV">Regi\xf3n de Los R\xedos</option>\n<option value="XV">Regi\xf3n de Arica-Parinacota</option>\n</select>'
 """
Index: django/tests/regressiontests/forms/localflavor/at.py
===================================================================
--- django/tests/regressiontests/forms/localflavor/at.py	(revision 9912)
+++ django/tests/regressiontests/forms/localflavor/at.py	(working copy)
@@ -4,7 +4,7 @@
 tests = r"""
 # ATZipCodeField ###########################################################

->>> from django.contrib.localflavor.at.forms import ATZipCodeField
+>>> from django.contrib.localflavor.at.forms import ATZipCodeField
 >>> f = ATZipCodeField()
 >>> f.clean('1150')
 u'1150'
@@ -61,7 +61,7 @@
 >>> from django.contrib.localflavor.at.forms import ATStateSelect
 >>> f = ATStateSelect()
 >>> f.render('bundesland', 'WI')
-u'<select name="bundesland">\n<option value="BL">Burgenland</option>\n<option value="KA">Carinthia</option>\n<option value="NO">Lower Austria</option>\n<option value="OO">Upper Austria</option>\n<option value="SA">Salzburg</option>\n<option value="ST">Styria</option>\n<option value="TI">Tyrol</option>\n<option value="VO">Vorarlberg</option>\n<option value="WI" selected="selected">Vienna</option>\n</select>'
+u'<select name="bundesland">\n<option value="">---------</option>\n<option value="BL">Burgenland</option>\n<option value="KA">Carinthia</option>\n<option value="NO">Lower Austria</option>\n<option value="OO">Upper Austria</option>\n<option value="SA">Salzburg</option>\n<option value="ST">Styria</option>\n<option value="TI">Tyrol</option>\n<option value="VO">Vorarlberg</option>\n<option value="WI" selected="selected">Vienna</option>\n</select>'

 # ATSocialSecurityNumberField ################################################

Index: django/tests/regressiontests/forms/localflavor/au.py
===================================================================
--- django/tests/regressiontests/forms/localflavor/au.py	(revision 9912)
+++ django/tests/regressiontests/forms/localflavor/au.py	(working copy)
@@ -122,6 +122,7 @@
 >>> f = AUStateSelect()
 >>> print f.render('state', 'NSW')
 <select name="state">
+<option value="">---------</option>
 <option value="ACT">Australian Capital Territory</option>
 <option value="NSW" selected="selected">New South Wales</option>
 <option value="NT">Northern Territory</option>
Index: django/tests/regressiontests/forms/localflavor/fr.py
===================================================================
--- django/tests/regressiontests/forms/localflavor/fr.py	(revision 9912)
+++ django/tests/regressiontests/forms/localflavor/fr.py	(working copy)
@@ -112,6 +112,7 @@
 >>> w = FRDepartmentSelect()
 >>> print w.render('dep', 'Paris')
 <select name="dep">
+<option value="">---------</option>
 <option value="01">01 - Ain</option>
 <option value="02">02 - Aisne</option>
 <option value="03">03 - Allier</option>
Index: django/tests/regressiontests/forms/localflavor/jp.py
===================================================================
--- django/tests/regressiontests/forms/localflavor/jp.py	(revision 9912)
+++ django/tests/regressiontests/forms/localflavor/jp.py	(working copy)
@@ -55,6 +55,7 @@
 >>> w = JPPrefectureSelect()
 >>> print w.render('prefecture', 'kanagawa')
 <select name="prefecture">
+<option value="">---------</option>
 <option value="hokkaido">Hokkaido</option>
 <option value="aomori">Aomori</option>
 <option value="iwate">Iwate</option>
Index: django/tests/regressiontests/forms/localflavor/nl.py
===================================================================
--- django/tests/regressiontests/forms/localflavor/nl.py	(revision 9912)
+++ django/tests/regressiontests/forms/localflavor/nl.py	(working copy)
@@ -68,5 +68,5 @@
 >>> from django.contrib.localflavor.nl.forms import NLProvinceSelect
 >>> s = NLProvinceSelect()
 >>> s.render('provinces', 'OV')
-u'<select name="provinces">\n<option value="DR">Drenthe</option>\n<option value="FL">Flevoland</option>\n<option value="FR">Friesland</option>\n<option value="GL">Gelderland</option>\n<option value="GR">Groningen</option>\n<option value="LB">Limburg</option>\n<option value="NB">Noord-Brabant</option>\n<option value="NH">Noord-Holland</option>\n<option value="OV" selected="selected">Overijssel</option>\n<option value="UT">Utrecht</option>\n<option value="ZE">Zeeland</option>\n<option value="ZH">Zuid-Holland</option>\n</select>'
+u'<select name="provinces">\n<option value="">---------</option>\n<option value="DR">Drenthe</option>\n<option value="FL">Flevoland</option>\n<option value="FR">Friesland</option>\n<option value="GL">Gelderland</option>\n<option value="GR">Groningen</option>\n<option value="LB">Limburg</option>\n<option value="NB">Noord-Brabant</option>\n<option value="NH">Noord-Holland</option>\n<option value="OV" selected="selected">Overijssel</option>\n<option value="UT">Utrecht</option>\n<option value="ZE">Zeeland</option>\n<option value="ZH">Zuid-Holland</option>\n</select>'
 """
Index: django/tests/regressiontests/forms/localflavor/it.py
===================================================================
--- django/tests/regressiontests/forms/localflavor/it.py	(revision 9912)
+++ django/tests/regressiontests/forms/localflavor/it.py	(working copy)
@@ -18,7 +18,7 @@
 >>> from django.contrib.localflavor.it.forms import ITRegionSelect
 >>> w = ITRegionSelect()
 >>> w.render('regions', 'PMN')
-u'<select name="regions">\n<option value="ABR">Abruzzo</option>\n<option value="BAS">Basilicata</option>\n<option value="CAL">Calabria</option>\n<option value="CAM">Campania</option>\n<option value="EMR">Emilia-Romagna</option>\n<option value="FVG">Friuli-Venezia Giulia</option>\n<option value="LAZ">Lazio</option>\n<option value="LIG">Liguria</option>\n<option value="LOM">Lombardia</option>\n<option value="MAR">Marche</option>\n<option value="MOL">Molise</option>\n<option value="PMN" selected="selected">Piemonte</option>\n<option value="PUG">Puglia</option>\n<option value="SAR">Sardegna</option>\n<option value="SIC">Sicilia</option>\n<option value="TOS">Toscana</option>\n<option value="TAA">Trentino-Alto Adige</option>\n<option value="UMB">Umbria</option>\n<option value="VAO">Valle d\u2019Aosta</option>\n<option value="VEN">Veneto</option>\n</select>'
+u'<select name="regions">\n<option value="">---------</option>\n<option value="ABR">Abruzzo</option>\n<option value="BAS">Basilicata</option>\n<option value="CAL">Calabria</option>\n<option value="CAM">Campania</option>\n<option value="EMR">Emilia-Romagna</option>\n<option value="FVG">Friuli-Venezia Giulia</option>\n<option value="LAZ">Lazio</option>\n<option value="LIG">Liguria</option>\n<option value="LOM">Lombardia</option>\n<option value="MAR">Marche</option>\n<option value="MOL">Molise</option>\n<option value="PMN" selected="selected">Piemonte</option>\n<option value="PUG">Puglia</option>\n<option value="SAR">Sardegna</option>\n<option value="SIC">Sicilia</option>\n<option value="TOS">Toscana</option>\n<option value="TAA">Trentino-Alto Adige</option>\n<option value="UMB">Umbria</option>\n<option value="VAO">Valle d\u2019Aosta</option>\n<option value="VEN">Veneto</option>\n</select>'

 # ITSocialSecurityNumberField #################################################

Index: django/tests/regressiontests/forms/localflavor/cz.py
===================================================================
--- django/tests/regressiontests/forms/localflavor/cz.py	(revision 9912)
+++ django/tests/regressiontests/forms/localflavor/cz.py	(working copy)
@@ -34,7 +34,7 @@
 >>> from django.contrib.localflavor.cz.forms import CZRegionSelect
 >>> w = CZRegionSelect()
 >>> w.render('regions', 'TT')
-u'<select name="regions">\n<option value="PR">Prague</option>\n<option value="CE">Cenral Bohemian Region</option>\n<option value="SO">South Bohemian Region</option>\n<option value="PI">Pilsen Region</option>\n<option value="CA">Carlsbad Region</option>\n<option value="US">Usti Region</option>\n<option value="LB">Liberec Region</option>\n<option value="HK">Hradec Region</option>\n<option value="PA">Pardubice Region</option>\n<option value="VY">Vysocina Region</option>\n<option value="SM">South Moravian Region</option>\n<option value="OL">Olomouc Region</option>\n<option value="ZL">Zlin Region</option>\n<option value="MS">Moravian-Silesian Region</option>\n</select>'
+u'<select name="regions">\n<option value="">---------</option>\n<option value="PR">Prague</option>\n<option value="CE">Cenral Bohemian Region</option>\n<option value="SO">South Bohemian Region</option>\n<option value="PI">Pilsen Region</option>\n<option value="CA">Carlsbad Region</option>\n<option value="US">Usti Region</option>\n<option value="LB">Liberec Region</option>\n<option value="HK">Hradec Region</option>\n<option value="PA">Pardubice Region</option>\n<option value="VY">Vysocina Region</option>\n<option value="SM">South Moravian Region</option>\n<option value="OL">Olomouc Region</option>\n<option value="ZL">Zlin Region</option>\n<option value="MS">Moravian-Silesian Region</option>\n</select>'

 # CZBirthNumberField ########################################################

Index: django/tests/regressiontests/forms/localflavor/ro.py
===================================================================
--- django/tests/regressiontests/forms/localflavor/ro.py	(revision 9912)
+++ django/tests/regressiontests/forms/localflavor/ro.py	(working copy)
@@ -86,28 +86,29 @@

 f = ROCountySelect()
 f.render('county','CJ')
-u'<select name="county">\n<option value="AB">Alba</option>\n<option value="AR">A
-rad</option>\n<option value="AG">Arge\u015f</option>\n<option value="BC">Bac\u01
-03u</option>\n<option value="BH">Bihor</option>\n<option value="BN">Bistri\u0163
-a-N\u0103s\u0103ud</option>\n<option value="BT">Boto\u015fani</option>\n<option
-value="BV">Bra\u015fov</option>\n<option value="BR">Br\u0103ila</option>\n<optio
-n value="B">Bucure\u015fti</option>\n<option value="BZ">Buz\u0103u</option>\n<op
-tion value="CS">Cara\u015f-Severin</option>\n<option value="CL">C\u0103l\u0103ra
-\u015fi</option>\n<option value="CJ" selected="selected">Cluj</option>\n<option
-value="CT">Constan\u0163a</option>\n<option value="CV">Covasna</option>\n<option
- value="DB">D\xe2mbovi\u0163a</option>\n<option value="DJ">Dolj</option>\n<optio
-n value="GL">Gala\u0163i</option>\n<option value="GR">Giurgiu</option>\n<option
-value="GJ">Gorj</option>\n<option value="HR">Harghita</option>\n<option value="H
-D">Hunedoara</option>\n<option value="IL">Ialomi\u0163a</option>\n<option value=
-"IS">Ia\u015fi</option>\n<option value="IF">Ilfov</option>\n<option value="MM">M
-aramure\u015f</option>\n<option value="MH">Mehedin\u0163i</option>\n<option valu
-e="MS">Mure\u015f</option>\n<option value="NT">Neam\u0163</option>\n<option valu
-e="OT">Olt</option>\n<option value="PH">Prahova</option>\n<option value="SM">Sat
-u Mare</option>\n<option value="SJ">S\u0103laj</option>\n<option value="SB">Sibi
-u</option>\n<option value="SV">Suceava</option>\n<option value="TR">Teleorman</o
-ption>\n<option value="TM">Timi\u015f</option>\n<option value="TL">Tulcea</optio
-n>\n<option value="VS">Vaslui</option>\n<option value="VL">V\xe2lcea</option>\n<
-option value="VN">Vrancea</option>\n</select>'
+u'<select name="county">\n<option value="">---------</option>\n
+<option value="AB">Alba</option>\n<option value="AR">Arad</option>\n<option valu
+e="AG">Arge\u015f</option>\n<option value="BC">Bac\u0103u</option>\n<option valu
+e="BH">Bihor</option>\n<option value="BN">Bistri\u0163a-N\u0103s\u0103ud</option
+>\n<option value="BT">Boto\u015fani</option>\n<optionvalue="BV">Bra\u015fov</opt
+ion>\n<option value="BR">Br\u0103ila</option>\n<option value="B">Bucure\u015fti<
+/option>\n<option value="BZ">Buz\u0103u</option>\n<option value="CS">Cara\u015f-
+Severin</option>\n<option value="CL">C\u0103l\u0103ra\u015fi</option>\n<option v
+alue="CJ" selected="selected">Cluj</option>\n<optionvalue="CT">Constan\u0163a</o
+ption>\n<option value="CV">Covasna</option>\n<option value="DB">D\xe2mbovi\u0163
+a</option>\n<option value="DJ">Dolj</option>\n<option value="GL">Gala\u0163i</op
+tion>\n<option value="GR">Giurgiu</option>\n<optionvalue="GJ">Gorj</option>\n<op
+tion value="HR">Harghita</option>\n<option value="HD">Hunedoara</option>\n<optio
+n value="IL">Ialomi\u0163a</option>\n<option value="IS">Ia\u015fi</option>\n<opt
+ion value="IF">Ilfov</option>\n<option value="MM">Maramure\u015f</option>\n<opti
+on value="MH">Mehedin\u0163i</option>\n<option value="MS">Mure\u015f</option>\n<
+option value="NT">Neam\u0163</option>\n<option value="OT">Olt</option>\n<option
+value="PH">Prahova</option>\n<option value="SM">Satu Mare</option>\n<option valu
+e="SJ">S\u0103laj</option>\n<option value="SB">Sibiu</option>\n<option value="SV
+">Suceava</option>\n<option value="TR">Teleorman</option>\n<option value="TM">Ti
+mi\u015f</option>\n<option value="TL">Tulcea</option>\n<option value="VS">Vaslui
+</option>\n<option value="VL">V\xe2lcea</option>\n<option value="VN">Vrancea</op
+tion>\n</select>'

 ##ROIBANField #################################################################

Index: django/tests/regressiontests/forms/localflavor/ca.py
===================================================================
--- django/tests/regressiontests/forms/localflavor/ca.py	(revision 9912)
+++ django/tests/regressiontests/forms/localflavor/ca.py	(working copy)
@@ -190,6 +190,7 @@
 >>> w = CAProvinceSelect()
 >>> print w.render('province', 'AB')
 <select name="province">
+<option value="">---------</option>
 <option value="AB" selected="selected">Alberta</option>
 <option value="BC">British Columbia</option>
 <option value="MB">Manitoba</option>
Index: django/tests/regressiontests/forms/localflavor/us.py
===================================================================
--- django/tests/regressiontests/forms/localflavor/us.py	(revision 9912)
+++ django/tests/regressiontests/forms/localflavor/us.py	(working copy)
@@ -185,6 +185,7 @@
 >>> w = USStateSelect()
 >>> print w.render('state', 'IL')
 <select name="state">
+<option value="">---------</option>
 <option value="AL">Alabama</option>
 <option value="AK">Alaska</option>
 <option value="AS">American Samoa</option>
Index: django/tests/regressiontests/forms/widgets.py
===================================================================
--- django/tests/regressiontests/forms/widgets.py	(revision 9912)
+++ django/tests/regressiontests/forms/widgets.py	(working copy)
@@ -492,6 +492,67 @@
 </optgroup>
 </select>

+# NullSelect Widget ####################################################
+
+>>> w = NullSelect()
+>>> print w.render('beatle', 'J', choices=(('J', 'John'), ('P', 'Paul'), ('G', 'George'), ('R', 'Ringo')))
+<select name="beatle">
+<option value="">---------</option>
+<option value="J" selected="selected">John</option>
+<option value="P">Paul</option>
+<option value="G">George</option>
+<option value="R">Ringo</option>
+</select>
+>>> print w.render('beatle', None, choices=(('J', 'John'), ('P', 'Paul'), ('G', 'George'), ('R', 'Ringo')))
+<select name="beatle">
+<option value="" selected="selected">---------</option>
+<option value="J">John</option>
+<option value="P">Paul</option>
+<option value="G">George</option>
+<option value="R">Ringo</option>
+</select>
+>>> w = NullSelect(choices=(('F', 'Fuji'), ('G', 'Granny Smith'), ('M', 'McIntosh')), empty_label="I don't like apples")
+>>> print w.render('apples', None)
+<select name="apples">
+<option value="" selected="selected">I don&#39;t like apples</option>
+<option value="F">Fuji</option>
+<option value="G">Granny Smith</option>
+<option value="M">McIntosh</option>
+</select>
+>>> print w.render('apples', 'R', choices=(('R', 'Red Delicious'), ('C', 'Cameo')), empty_label='No preference')
+<select name="apples">
+<option value="">No preference</option>
+<option value="F">Fuji</option>
+<option value="G">Granny Smith</option>
+<option value="M">McIntosh</option>
+<option value="R" selected="selected">Red Delicious</option>
+<option value="C">Cameo</option>
+</select>
+>>> print w.render('apples', None, empty_label=None)
+<select name="apples">
+<option value="F">Fuji</option>
+<option value="G">Granny Smith</option>
+<option value="M">McIntosh</option>
+</select>
+>>> w = NullSelect(empty_label=None)
+>>> print w.render('beatle', 'J', choices=(('J', 'John'), ('P', 'Paul'), ('G', 'George'), ('R', 'Ringo')))
+<select name="beatle">
+<option value="J" selected="selected">John</option>
+<option value="P">Paul</option>
+<option value="G">George</option>
+<option value="R">Ringo</option>
+</select>
+>>> print w.render('beatle', 'J', choices=(('J', 'John'), ('P', 'Paul'), ('G', 'George'), ('R', 'Ringo')), empty_label='XXX')
+<select name="beatle">
+<option value="">XXX</option>
+<option value="J" selected="selected">John</option>
+<option value="P">Paul</option>
+<option value="G">George</option>
+<option value="R">Ringo</option>
+</select>
+
+""" + \
+r""" # [This concatenation is to keep the string below the jython's 32K limit].
 # NullBooleanSelect Widget ####################################################

 >>> w = NullBooleanSelect()
@@ -526,8 +587,6 @@
 <option value="3" selected="selected">No</option>
 </select>

-""" + \
-r""" # [This concatenation is to keep the string below the jython's 32K limit].
 # SelectMultiple Widget #######################################################

 >>> w = SelectMultiple()
